
/*

Copyright (C) 2000, 2001, 2002 Christian Kreibich <christian@whoop.org>.

Permission is hereby granted, free of charge, to any person obtaining a copy
of this software and associated documentation files (the "Software"), to
deal in the Software without restriction, including without limitation the
rights to use, copy, modify, merge, publish, distribute, sublicense, and/or
sell copies of the Software, and to permit persons to whom the Software is
furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in
all copies of the Software and its documentation and acknowledgment shall be
given in the documentation and software packages that this Software was
used.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
THE AUTHORS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER
IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN
CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.

*/
#ifndef __nd_misc_h
#define __nd_misc_h

#include <stdlib.h>
#include <net/if.h>
#include <gtk/gtk.h>
#include <netdude/nd_protocol.h>

int       nd_misc_ones_complement_checksum(const void *p, int b, u_int32_t sum);
u_short   nd_misc_in_cksum(register u_short *addr, register int len, u_int preadd);
gboolean  nd_misc_exists(const char *filename);
gboolean  nd_misc_can_read(const char *filename);
gboolean  nd_misc_is_tcpdump_file(const char *filename);
gboolean  nd_misc_can_exec(const char *filename);
gboolean  nd_misc_is_dir(const char *filename);

/* Simple compare function for pointers that can be casted (NOT
 * dereferenced) to ints, returning -1/0/1 of row1 is smaller/
 * equal/larger than row2
 */
gint      nd_misc_int_cmp(gconstpointer int1, gconstpointer int2);

char     *nd_misc_add_slash(char *filename);

/* Returns an alphabetically ordered list of strings containing
 * the names of those network interfaces that satisfy the given
 * flag combination of IFF_xxx values.
 */
GList    *nd_misc_get_if_names(int flags);

/* Returns MTU for a given interface. I have no idea whether this
 * compiles on anything non-Linux ...
 */
int       nd_misc_get_if_mtu(const char *ifname);

void      nd_misc_get_hardware_string(char *str, guint str_len, guchar *address, guint addr_len);

char     *nd_misc_get_unnamed_string(void);

#endif
     
